package com.jiuqi.syntax;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.jiuqi.syntax.CommonData;
import com.jiuqi.syntax.DataCell;
import com.jiuqi.syntax.NiporlanItem;
import java.util.ArrayList;

public final class Niporlan implements Cloneable {
  public static int NP_NEW_COUNT = 0;
  
  public static int NP_LIVE_COUNT = 0;
  
  public ArrayList ifItems;
  
  public ArrayList thenItems;
  
  public ArrayList elseItems;
  
  public Niporlan() {
    NP_NEW_COUNT++;
    NP_LIVE_COUNT++;
    this.thenItems = new ArrayList(5);
  }
  
  protected void finalize() throws Throwable {
    NP_LIVE_COUNT--;
    super.finalize();
  }
  
  public ArrayList getIfItems() {
    return this.ifItems;
  }
  
  public ArrayList getThenItems() {
    return this.thenItems;
  }
  
  public ArrayList getElseItems() {
    return this.elseItems;
  }
  
  public boolean isEmpty() {
    if ((this.ifItems == null || this.ifItems.isEmpty()) && 
      this.thenItems.isEmpty() && (
      this.elseItems == null || this.elseItems.isEmpty()))
      return true; 
    return false;
  }
  
  public boolean isBalance() {
    if (elseExist()) {
      NiporlanItem item = this.thenItems.get(this.thenItems.size() - 1);
      if (item.getType() == 0 && item.getOp() == 7) {
        NiporlanItem item2 = this.elseItems.get(this.elseItems.size() - 1);
        return (item2.getType() == 0 && item2.getOp() == 7);
      } 
      return false;
    } 
    if (this.thenItems.size() > 0) {
      NiporlanItem item = this.thenItems.get(this.thenItems.size() - 1);
      return (item.getType() == 0 && item.getOp() == 7);
    } 
    return false;
  }
  
  public com.jiuqi.syntax.Niporlan transBalanceToMinus() {
    com.jiuqi.syntax.Niporlan minusNiporlan = (com.jiuqi.syntax.Niporlan)clone();
    if (minusNiporlan.elseExist()) {
      NiporlanItem item = minusNiporlan.thenItems.get(minusNiporlan.thenItems.size() - 1);
      if (item.getType() == 0 && item.getOp() == 7) {
        item.setOp(2);
        NiporlanItem item2 = minusNiporlan.elseItems.get(minusNiporlan.elseItems.size() - 1);
        if (item2.getType() == 0 && item2.getOp() == 7)
          item2.setOp(2); 
      } 
    } else {
      NiporlanItem item = minusNiporlan.thenItems.get(this.thenItems.size() - 1);
      if (item.getType() == 0 && item.getOp() == 7)
        item.setOp(2); 
    } 
    return minusNiporlan;
  }
  
  public boolean isOneCell() {
    if (ifExist())
      return false; 
    if (this.thenItems.size() != 1)
      return false; 
    NiporlanItem item = this.thenItems.get(0);
    return (item.getType() == 3);
  }
  
  public DataCell getFirstCell() {
    int i;
    for (i = 0; this.ifItems != null && i < this.ifItems.size(); i++) {
      NiporlanItem item = this.ifItems.get(i);
      if (item.getType() == 3)
        return item.getDataCell(); 
    } 
    for (i = 0; i < this.thenItems.size(); i++) {
      NiporlanItem item = this.thenItems.get(i);
      if (item.getType() == 3)
        return item.getDataCell(); 
    } 
    for (i = 0; this.elseItems != null && i < this.elseItems.size(); i++) {
      NiporlanItem item = this.elseItems.get(i);
      if (item.getType() == 3)
        return item.getDataCell(); 
    } 
    return null;
  }
  
  public boolean ifExist() {
    return (this.ifItems != null && this.ifItems.size() > 0);
  }
  
  public boolean elseExist() {
    return (this.elseItems != null && this.elseItems.size() > 0);
  }
  
  public void clear() {
    if (this.ifItems != null)
      this.ifItems.clear(); 
    this.thenItems.clear();
    if (this.elseItems != null)
      this.elseItems.clear(); 
  }
  
  public String toString() {
    return "";
  }
  
  public void addIfItem(NiporlanItem ni) {
    if (this.ifItems == null)
      this.ifItems = new ArrayList(3); 
    this.ifItems.add(ni);
  }
  
  public void addIfItem(int op) {
    if (this.ifItems == null)
      this.ifItems = new ArrayList(3); 
    this.ifItems.add(new NiporlanItem(op));
  }
  
  public void addIfItem(String funcName) {
    if (this.ifItems == null)
      this.ifItems = new ArrayList(3); 
    this.ifItems.add(new NiporlanItem(funcName));
  }
  
  public void addIfItem(CommonData commonData) {
    if (this.ifItems == null)
      this.ifItems = new ArrayList(3); 
    this.ifItems.add(new NiporlanItem(commonData));
  }
  
  public void addIfItem(DataCell dataCell) {
    if (this.ifItems == null)
      this.ifItems = new ArrayList(3); 
    this.ifItems.add(new NiporlanItem(dataCell));
  }
  
  public void addIfItem(Object object) {
    if (this.ifItems == null)
      this.ifItems = new ArrayList(3); 
    this.ifItems.add(new NiporlanItem(object));
  }
  
  public void addThenItem(NiporlanItem ni) {
    this.thenItems.add(ni);
  }
  
  public void addThenItem(int op) {
    this.thenItems.add(new NiporlanItem(op));
  }
  
  public void addThenItem(String funcName) {
    this.thenItems.add(new NiporlanItem(funcName));
  }
  
  public void addThenItem(CommonData commonData) {
    this.thenItems.add(new NiporlanItem(commonData));
  }
  
  public void addThenItem(DataCell dataCell) {
    this.thenItems.add(new NiporlanItem(dataCell));
  }
  
  public void addThenItem(Object object) {
    this.thenItems.add(new NiporlanItem(object));
  }
  
  public void addElseitem(NiporlanItem ni) {
    if (this.elseItems == null)
      this.elseItems = new ArrayList(5); 
    this.elseItems.add(ni);
  }
  
  public void addElseItem(int op) {
    if (this.elseItems == null)
      this.elseItems = new ArrayList(5); 
    this.elseItems.add(new NiporlanItem(op));
  }
  
  public void addElseItem(String funcName) {
    if (this.elseItems == null)
      this.elseItems = new ArrayList(5); 
    this.elseItems.add(new NiporlanItem(funcName));
  }
  
  public void addElseItem(CommonData commonData) {
    if (this.elseItems == null)
      this.elseItems = new ArrayList(5); 
    this.elseItems.add(new NiporlanItem(commonData));
  }
  
  public void addElseItem(DataCell dataCell) {
    if (this.elseItems == null)
      this.elseItems = new ArrayList(5); 
    this.elseItems.add(new NiporlanItem(dataCell));
  }
  
  public void addElseItem(Object object) {
    if (this.elseItems == null)
      this.elseItems = new ArrayList(5); 
    this.elseItems.add(new NiporlanItem(object));
  }
  
  public Object clone() {
    com.jiuqi.syntax.Niporlan newNiporlan = new com.jiuqi.syntax.Niporlan();
    int i;
    for (i = 0; this.ifItems != null && i < this.ifItems.size(); i++) {
      NiporlanItem item = new NiporlanItem();
      item.assign(this.ifItems.get(i));
      newNiporlan.getIfItems().add(item);
    } 
    for (i = 0; i < this.thenItems.size(); i++) {
      NiporlanItem item = new NiporlanItem();
      item.assign(this.thenItems.get(i));
      newNiporlan.getThenItems().add(item);
    } 
    for (i = 0; this.elseItems != null && i < this.elseItems.size(); i++) {
      NiporlanItem item = new NiporlanItem();
      item.assign(this.elseItems.get(i));
      newNiporlan.getElseItems().add(item);
    } 
    return newNiporlan;
  }
}
